<!DOCTYPE HTML>
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="fr" lang="fr">

<head>
{% include 'templates/favicon.html' %}
{% include 'templates/global.css.html' %}

    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
    <title>Tibibo:ce2</title>
    <script type="text/javascript" src="ext/js/jquery.min.js"></script>
    <script type="text/javascript" src="ext/js/jquery-ui.min.js"></script>
    <script type="text/javascript" src="ext/js/jquery.ui.touch-punch.min.js"></script>
    <script type="text/javascript" src="ext/js/jquery.svg.min.js"></script>
    <script type="text/javascript" src="ext/js/jquery.cookie.js"></script>
    <script type="text/javascript" src="js/jlodb.js"></script>
    <script type="text/javascript" src="js/jquery.jlodb.menu.js"></script>
    <script type="text/javascript" src="js/jlodb-ext.js"></script>
    <script type="text/javascript" src="user/standalone.js"></script>
    <link type="text/css" rel="stylesheet" href="css/jlodb.css" media="all" />
    <link type="text/css" rel="stylesheet" href="user/style.css" media="all" />
    <link rel="icon" type="image/png" href="favicon.ico" />
    <link rel="apple-touch-icon-precomposed" href="mods/tibibo/res/img/icon/icon144.png" />
    <link rel="apple-touch-icon-precomposed" sizes="72x72" href="mods/tibibo/res/img/icon/icon72.png" />
    <link rel="apple-touch-icon-precomposed" sizes="114x114" href="mods/tibibo/res/img/icon/icon114.png" />
    <link rel="apple-touch-icon-precomposed" sizes="144x144" href="mods/tibibo/res/img/icon/icon144.png" />
    <meta name="apple-mobile-web-app-capable" content="yes"/>
    <style>
    
#waiting                    { top:50%; left:72%; font-size:4em; }
#bomain .usermode           { display:inline; }
#bomain .devmode            { display:none; }
#bomain.devmode .usermode   { display:none; }
#bomain.devmode .devmode    { display:inline; }
#bomain                     { position:relative; background-image:url('res/img/background/landscape/blueboard01.svg'); display:none; }

#bomain ##g_scoreaward         { position:absolute; font-size:4em; top:10%; left:70%; background-image:url("res/img/icon/tab/tab00.svg"); border-radius:.5em; overflow:visible; background-color:#69b5cd;}

#bosplash					{ background-image:url("res/img/default/background/jlodb01.svg"); position:absolute; top:0;left:0; background-color:#0A0A0A; width:100%; height:100%; z-index:5; display:none; }
#bosplash>div			{ color:white; margin:20% auto; width:75%; height:50%; background-image:url("res/img/banners/jlodb_tibibo.svg"); background-repeat:no-repeat;}
#bosplash #bolabel			{ font-weight:bold; margin-top:24%; margin-left:1%; font-size:.4em;  }

.topdown                    { font-size:.3em; width:105%; margin:.5em 0 .2em 0; overflow:visible; }
.topdown>div                { height:3em; border-radius:.25em; float:left; margin-left:1em;  }
#bonav                      { background-color:#DD5; width:70%; overflow:visible; margin-right:.5em; }
#boheader #bonav .label     { float:right; width:14em; border:0; font-size:1em; background-color:#DD5; border-radius:.25em; color:#048;  }
#boheader #bonav .label.ex  { font-size:2.2em; font-family:inherit; font-weight:bold; height:1.2em; }
#boheader #bonav .node      { font-size:2.8em; margin:.05em .1em; }

#boheader #profile          { background-color:#9B6; width:20%; color:white; float:inherit; }
#boheader #profile>*        { float:left; }
#boheader #profile #avatar  { background-color:#444; font-size:3em; border-radius:.1em; cursor:pointer; }
#boheader #profile #label   { margin-left:.2em;  font-size:.7em; width:5.2em; }
#boheader #profile #sub     { font-size:.8em; color:yellow; }
#boheader #profile #edmode  { font-size:2em; opacity:0.3; display:none; cursor:pointer; }
.devmode #boheader #edmode  { opacity:1 !important; }
#boheader #profile #out     { font-size:3em; cursor:pointer; display:none; float:right; }
#boheader #profile #out.s   { background-color:red; border-radius:.5em; }

#bocontent                  { width:100%; height:9em; }
#bocontent>div              { width:100%; display:none; }

#boquitpanel            { position:absolute;top:0;left:0;width:100%;height:100%;background-color:rgba(0,0,0,0.4); display:none;z-index:3; }
#boquitpanel>div               { background-color:rgba(255,255,240,0.9); width:70%;height:30%;margin-top:20%;margin-left:15%;border:.1em solid white; }
#boquitpanel #boquitask	{ text-align:center; background-color:gray; color:white; }
#boquitpanel .icon		{ margin:.1em .5em; font-size:2em; cursor:pointer; float:left; }
#boquitpanel #boquitcancel.icon { float:right; }

#boawards                   { position:absolute;top:0;left:0;width:100%;height:100%;background-color:rgba(0,0,0,0.4); display:none;z-index:3; }
#boawards>div               { background-color:rgba(255,255,240,0.9); width:92%;height:86%;margin-top:4%;margin-left:4%;border:.1em solid white; }
#boawards #boawardsedit     { font-size:0.5em; height:3em; background-color:#9B6;padding:.1em 0; }
#boawards #boawardsedit>*   { float:left; margin-left:1%; height:100%; }
#boawards #img              { font-size:3em; background-image:url("res/img/icon/tab/tab00.svg"); border-radius:.5em; overflow:visible; background-color:red; cursor:pointer; }
#boawards #colors           { width:3em; }
#boawards #colors>div       { font-size:.72em; float:left; cursor:pointer; }
#boawards textarea          { background-color:rgba(255,255,255,0.4); font-size:.5em; width:27%; height:95%; border:0; font-family:inherit;padding:0 .2em; }
#boawards #goals            { width:35%; font-size:.4em; }
#boawards #goals>*          { margin-bottom:.4em; }
#boawards .goal>*           { float:left; }
#boawards .goal select      { width:35%; border:0; background-color:rgba(255,255,255,0.4); font-size:1em; }
#boawards .goal input       { width:12%; border:0; font-size:1em; text-align:right;font-family:inherit; }
#boawards .goal .max        { float:left; background-color:rgba(255,255,255,0.4); width:12%; }
#boawards #add              { font-size:3em; cursor:pointer; }

#boawardscontent            { height:8.5em; width:100%; overflow:auto; }
#boawardscontent.small      { height:70%; }
#boawardscontent .boawelt   { font-size:1.4em; float:left; width:5em; height:1em; background-color:rgba(150,150,150,0.6); margin:.05em; padding:.05em 0; position:relative; }
#boawardscontent .boawelt.new { background-color:rgba(255,150,150,0.6); cursor:help; }
#boawardscontent .boawelt.done { background-color:rgba(150,220,255,0.6); }
#boawardscontent .label     { font-size:.12em; width:48%; margin-left:2%; }
#boawardscontent .img       { background-image:url("res/img/icon/tab/tab00.svg"); border-radius:.5em; overflow:visible; margin-left:.05em; max-width:20%; background-repeat:no-repeat; }
.boawelt>div                { float:left; overflow:visible; }
#boawardscontent .progress  { width:25%; height:100%; font-size:.2em; cursor:pointer; float:right; margin-right:1%; }
#boawardscontent .progress.n1 .slider { height:5em; }
#boawardscontent .progress.n1 .value  { top:1.5em; }
#boawardscontent .progress.n2 .slider { height:2.5em; }
#boawardscontent .progress.n2 .value  { top:0.75em; }
#boawardscontent .progress.n3 .slider { height:1.6em; }
#boawardscontent .progress.n3 .value  { top:0.2em; }
#boawardscontent .slider    { width:100%; height:1.2em; background-color:#dd5; position:relative; margin:.05em 0; overflow:visible; }
#boawardscontent .slider .bar { position:absolute; top:0; left:0; height:100%; width:0%; background-color:#5b6; }
#boawardscontent .slider .value { position:absolute; top:0; left:0; width:100%; color:white; text-align:center; }
#boawardscontent .progress .icon { position:absolute; top:0; left:0; font-size:1em;  }
#boawardscontent #edit       { font-size:.5em; position:absolute; top:60%; left:20%; cursor:pointer; }
#boawardscontent #move       { font-size:.5em; position:absolute; top:60%; left:30%; cursor:pointer; }
#boawardscontent #del        { font-size:.5em; position:absolute; top:60%; left:65%; cursor:pointer; }

#boawardscontent .g_anim12    { position:absolute; font-size:2em; }
#boawardscontent .fire1     { top:-.3em; left:-.3em; }
#boawardscontent .fire2     { top:-.2em; left:-.2em; }

#boawardsnav				{ height:10%; width:100%; font-size:0.5em;  }
#boawardsnav>div			{ float:left; cursor:pointer; margin:0.1em 0.5em; width:1.4em; height:1.4em; text-align:center; background-color:gray; color:white; border-radius:.2em; }
#boawardsnav>div.s			{ background-color:red; }

#boerror                    { position:absolute; top:72%; font-size:.7em; display:none; text-align:center;  }
#bomain .redline            { background-color:red; width:102%; color:white; opacity:0.9; height:1.2em; }
#bohome .input              { margin-top:1em; font-size:0.8em; }
#bohome .input form>*       { float:left; margin-left:.5em; }
#bohome .input .label       { width:9em; white-space:nowrap; }
#bohome .input input        { font-size:1em; width:7em; color:#500; padding-left:.5em; float:left; }
#bohome .input input.s      { color:gray; }
#bohome .input .icon        { font-size:1.2em; cursor:pointer; }
.booklist                   { font-size:0.5em; border:.2em solid black; margin-top:1em; height:12.5em;}
.booklist .title            { background-color:black; color: white; padding-left:2em; height:1.2em; }
.booklist .list             { height:11.3em; overflow-x:none; overflow-y:auto; }
.booklist .list>div         { margin:.2em 0.2em; cursor:pointer; clear:both; height:1.2em; width:31em; }
.booklist .list .bookid     { float:left; width:5em; background-color:rgba(150,220,255,0.6); padding-right:.5em; color:#345; text-align:right; font-weight:bold; }
.booklist .list .label      { float:left; margin-left:.1em; background-color:rgba(255,220,150,0.6); color:#543; width:24em; padding-left:.5em; font-style:italic; white-space:nowrap; }


#bomain .node               { width:1em; height:1.35em; margin:.08em; cursor:pointer; float:left; position:relative; }
#boheader #bonav .node      { height:1em; margin:0.05em; border-radius:.2em; overflow:visible; }
#bomain .node .icon         { width:1em; height:1em; }
#bomain .node .star         { width:1em; height:1em; position:absolute; top:0.1em; left:0.03em; display:none; }
#bomain .node .label        { font-size:.08em; position:absolute; top:74%; left:5%; width:90%; height:2.8em; }
#bomain .node.s .star       { display:inline; }
#bomain .node .done         { position:absolute; top:0.1em; left:3.5em; font-size:.15em; width:3em; text-align:center; background-color:rgba(20,200,50,0.8); color:white; font-weight:bold; border:.1em solid white; -ms-transform: rotate(10deg); border-radius:.3em; -webkit-transform: rotate(10deg); transform: rotate(10deg);   }
#bomain .node .progress     { width:1em; height:0.2em; position:absolute; top:93%; background-color:#dd5; }
#bomain .node .progress>div { height:100%; background-color:#5b6; }
#bomain .node .id           { position:absolute; top:70%; left:40%; width:50%; text-align:right; font-size:0.4em; font-weight:bold; opacity:0.1; }
#bomain .node .mask         { position:absolute; top:0; left:0; width:100%; height:100%; background-color:rgba(255,255,0,0.8); border-radius:.2em; opacity:0; }

#boframe .node              { margin:.02em; padding:.02em; background-color:rgba(0,0,0,0.6); border-radius:.26em; border:.04em solid white; color:white}

#bofooter                   { clear:both; background-color:#aaa; width:100%; height:5.2em; color:white;}
#bofooter>div               { font-size:4.2em; float:left; margin:.1em; cursor:pointer; border-radius:.1em; display:none; }
#bofooter #oshuffle			{ font-size:3.7em; float:left; height:1em; width:1em; border:.1em solid white; background-color:#5b6; }
#bofooter #oshuffle.d		{ opacity:0.5; cursor:auto; background-color:#888; }
#bofooter #olist            { font-size:3.7em; height:1em; width:1em; border:.1em solid white; padding:0; background-color:#dd5; position:relative; float:left;  }
#bofooter #olist .value     { position:absolute;text-align:center;font-size:.8em;width:1.2em;height:1.2em;top:0;z-index:2; }
#bofooter #olist .slide     { background-color:#5b6;position:absolute;width:1em;height:1em;top:1em;z-index:1; }
#bofooter #oquit            { float:right; margin-right:.2em; }
#bofooter #ofullscreen      { float:right; margin-right:.2em; font-size:3.7em; height:1em; width:1em; border:.1em solid white; background-color:#5b6;}
#bofooter #oactions         { font-size:2em; }
#bofooter .action.icon.s    { background-color:#A00; }
#bofooter .action.icon      { background-image:url("res/img/icon/tab/tab00.svg"); border-radius:.5em; float:left; margin-right:.1em; width:1em; height:1em; }
#bofooter .bolink           { font-style:italic; }
#bofooter .bolink:before    { content:"("; }
#bofooter .bolink:after     { content:")"; }
#bofooter .bostrong         { font-size:1em; display:inline; }
#bofooter #mmove>div	{ font-size:.5em; width:2em; text-align:center; margin-top:.3em; font-weight:bold; }

#boeditnode                 { position:absolute; top:0; left:0; width:16em; height:12em; background-color: rgba(0,0,0,0.2); display:none; }
#boeditnode>div             { position:absolute; font-size:.4em; width:20em; height:21em; top:2em; left:2em;  background-color:rgba(128,120,100,0.9); border:.2em solid white; color:black; border-radius:.5em; background-image:url("res/img/default/pattern/line04.svg"); background-repeat:repeat; }
#boeditnode #eimg           { width:15em; left:23em; }
#boeditnode #eimg .icon     { float:left; cursor:pointer; margin:0.05em; font-size:1.4em; }
#boeditnode #settings       { height:16em; }
#boeditnode #nodeimg        { font-size:8em; float:left; margin:0.05em; height:1.1em; }
#boeditnode textarea        { float:right; margin-top:0.8em; padding:.2em; font-size:0.6em; width:17.5em; border:0; background-color:white; border-radius:.5em 0 0 .5em; height:7.5em;  }
#boeditnode #elabel         { height:3.5em; }
#boeditnode #tibibi         { clear:both;}
#boeditnode #tibibi select  { border:0; background-color:white; border-radius:00; float:left; font-size:1em; width:18em; }
#boeditnode #tibibi .icon   { float:left; background-color:#444; padding:.1em .5em; border-radius:0; cursor:pointer; }
#boeditnode #tibibi textarea{ clear:both; border-radius:0; width:33em; float:none; }
#boeditnode #evalid         { font-size:4em; float:right; margin:.1em; cursor:pointer;}
#boeditnode #ecancel        { font-size:4em; float:left; margin:.1em; cursor:pointer; }

#boframe                    { height:100%;font-size:3em; margin-left:.2em; overflow:visible; }

#boframe .jmenu             { font-size:0.45em; background-color:rgba(255,255,255,0.6); width:95%; margin-left:-0.2em;height:97%; margin-top:.1em; border-radius:.3em; overflow:hidden; }
#boframe .jmenu .icon       { background-image:url('res/img/default/icon/menu02bg.svg') !important; }


.bostrong            { font-size:1.5em; font-weight:bold; text-align:center; }

#bomain #congrats			{ position:absolute; top:1%; left:30%; font-size:1em; background-color:rgba(20,200,50,0.8); color:white; width:75%; border:.1em solid white; z-index:3; border-radius:.5em; text-align:center; font-weight:bold; display:none; }



    </style>
    <script>
    
// TEXT FORMATING
var regExp = [
        "\\\[b\\\]([^\\\[]+)\\\[/b\\\]",            "<b>$1</b>",
        "\\\[i\\\]([^\\\[]+)\\\[/i\\\]",            "<i>$1</i>",
        "\\\[br\\\]",                               "<br/>",
        "\\\[dot\\\]",                              "<div style='clear:left'></div><div style='margin:0 .5em 0 1em;float:left;'>•</div>",
        "\\\[clear\\\]",                            "<div style='clear:both'></div>",
        "\\\[blue\\\]([^\\\[]+)\\\[/blue\\\]",      "<span style='color:blue'>$1</span>",
        "\\\[red\\\]([^\\\[]+)\\\[/red\\\]",        "<span style='color:red'>$1</span>",
        "\\\[icon\\\]([^\\\[]+)\\\[/icon\\\]",      "<div class='icon'><img src='$1'/></div>",
        "\\\[img\\\]([^\\\[]+)\\\[/img\\\]",        "<div class='img'><img src='$1'/></div>",
        "\\\[strong\\\](.+)\\\[/strong\\\]",        "<div class='bostrong'>$1</div>"
    ];

// USER EVENT CALLBACK (FROM user/standalone.js)
user.onEvent = function() {
    // IDENTIFIED
    if (user.islogged()) {
        if (tibibo.standalone) {
            $("#profile #avatar").html($("#logpanel #u"+user.settings.id+" img").clone());
            $("#profile #label #edmode").hide();
        }
        else {
            $("#profile #avatar").gonz({interactive:false, code:user.settings.avatar,
                                    context:{onclick:function($this){},onquit:function($this, _ret){}}});
            $("#profile #label #edmode").show();
        }
        $("#profile #label #name").html(user.settings.name);
        if (user.settings.tag) { $("#profile #label #sub").html("#"+user.settings.tag); }
        $("#bomain #profile #out").show();
    }
    // ANONYMOUS MODE
    else {
        $("#profile #avatar").html("<img src='res/img/default/white/people.svg'/>");
        $("#profile #label #name").html("");
        $("#profile #label #sub").html("");
        $("#profile #label #edmode").hide();
        $("#bomain #profile #out").hide();
    }
    
    tibibo.init();
};

var tibibo = {
// ----------- EXPORT PART ---------------
	standalone      : true,
	savemode		: "local",
	platform		: "file",
	bookname		: "ce2",
	version			: "19.10.0",
// ---------------------------------------
	
    lang            : "",
    args            : {},
    locale          : {},
	close			: function() {
		$("#boquitpanel").hide();
		if (tibibo.platform=="default") { document.location="tibibo.html"; } else
		if (tibibo.platform=="file")    { window.open('','_parent',''); window.close(); } // DO NOT WORK !
	},
	fullscreen      : function() {
		if (!document.fullscreenElement && !document.mozFullScreenElement &&
		    !document.webkitFullscreenElement && !document.msFullscreenElement ) {
		if (document.documentElement.requestFullscreen) {
		  document.documentElement.requestFullscreen();
		} else if (document.documentElement.msRequestFullscreen) {
		  document.documentElement.msRequestFullscreen();
		} else if (document.documentElement.mozRequestFullScreen) {
		  document.documentElement.mozRequestFullScreen();
		} else if (document.documentElement.webkitRequestFullscreen) {
		  document.documentElement.webkitRequestFullscreen(Element.ALLOW_KEYBOARD_INPUT);
		}
	  } else {
		if (document.exitFullscreen)			{ document.exitFullscreen(); } 		else
		if (document.msExitFullscreen) 			{ document.msExitFullscreen(); } 	else
		if (document.mozCancelFullScreen) 		{ document.mozCancelFullScreen(); } else
		if (document.webkitExitFullscreen) 		{ document.webkitExitFullscreen(); }
	  }
	},
    user            : function() {
        if (user.settings.name || tibibo.standalone ) { user.edit.open(); }
        else                                          { $("#logpanel").show(); }
    },
    helpers         : {
        format: function(_text, _to) {
            if (_text) {
                for (var j=0; j<2; j++) for (var i=0; i<regExp.length/2; i++) {
                    var vReg = new RegExp(regExp[i*2],"g");
                    _text = _text.replace(vReg,_to?_to:regExp[i*2+1]);
                }
            } else {_text=""; }
            return _text;
        },
        cleantext: function(_text) {
			if (_text) {
				var vReg1 = new RegExp("\"","g");
				_text = _text.replace(vReg1,"'");
				
				var vReg2 = new RegExp("\n","g");
				_text = _text.replace(vReg2,"[br]");
			}
            return _text; 
        },
        devmode: function() {
            if ($("#bomain").hasClass("devmode")) { user.devmode(); } else { $("#udevmode").show(); }
        },
        // HANDLE A BOOK NAVIGATION
        nav : function(_data) {
            if (!_data) { _data = []; }
            return {
                content : {id:-1, description:"", label:"(*)", children:_data },
                root    : function() { return -1; },
                getnode : function(_id, _node) {
                    if (!_node) { _node=this.content; }
                    if (_node.id==_id) { return _node; }
                    else for (i in _node.children) {
                        var ret = this.getnode(_id, _node.children[i]); if (ret) { return ret; }
                    }
                    return 0;
                },
                getparents: function(_id,_node) {
                    var ret = [];
                    if (!_node) { _node=this.content; }
                    if (_node.id==_id) { ret=[_node.id]; }
                    else for (i in _node.children) {
                        var tmp = this.getparents(_id, _node.children[i]);
                        if (tmp.length) { ret=tmp; ret.push(_node.id); }
                    }
                    return ret;
                },
                getparentnode: function(_id) { var p = this.getparents(_id); return this.getnode(p[1]); },
                getmaxid: function(_node) {
                    var ret = -1;
                    if (!_node) { _node=this.content; }
                    if (_node.id>ret) { ret = _node.id; }
                    for (var i in _node.children) { ret = Math.max(ret, this.getmaxid(_node.children[i])); }
                    return ret;
                },
                left: function(_id) {
                    var p=this.getparentnode(_id);
                    var idx=-1; for (var i=0; i<p.children.length; i++) { if (p.children[i].id==_id) { idx = i; }}
                    if (idx>0) { p.children.splice(idx-1, 0, p.children.splice(idx, 1)[0]); }
                    return idx;
                },
                right: function(_id) {
                    var p=this.getparentnode(_id);
                    var idx=-1; for (var i=0; i<p.children.length; i++) { if (p.children[i].id==_id) { idx = i; }}
                    if (idx<p.children.length-1) { p.children.splice(idx+1, 0, p.children.splice(idx, 1)[0]); }
                    return idx;
                },
                del: function(_id) {
                    var p=this.getparentnode(_id);
                    var idx=-1; for (var i in p.children) { if (p.children[i].id==_id) { idx = i; }}
                    p.children.splice(idx,1);
                    return idx;
                },
                each: function(_node, _cbk) {
                    if (!_node) { _node=this.content; }
                    _cbk(_node);
                    for (var i in _node.children) { this.each(_node.children[i], _cbk); }
                }
            };
        }
    },
    awards: {
        colors: ["#FFF","#F00","#0F0","#00F","#0FF","#F0F","#FF0","#800","#080","#008","#0F8","#08F","#80F","#F08","#F80","#8F0"],
        icons: [ "res/img/svginventoryicons/award/diploma01.svg",
                 "res/img/svginventoryicons/award/diploma02.svg",
                 "res/img/svginventoryicons/award/diploma03.svg",
                 "res/img/svginventoryicons/award/diploma04.svg",
                 "res/img/svginventoryicons/award/diploma05.svg",
                 "res/img/svginventoryicons/award/medal01.svg",
                 "res/img/svginventoryicons/award/medal02.svg",
                 "res/img/svginventoryicons/award/medal03.svg",
                 "res/img/svginventoryicons/award/medal04.svg"],
        init    : {color:0, icon:0, label:"description", type:[1,0,0,0], value:[0,0,0,0] },
		pageid	: 0,
        current : 0,
        selected: -1,
        list    : [],
        color   : function(_c) {
            tibibo.awards.current.color=_c;
            $("#boawards #img").css("background-color",tibibo.awards.colors[tibibo.awards.current.color]);
        },
        icon    : function() {
            tibibo.awards.current.icon=(tibibo.awards.current.icon+1)%tibibo.awards.icons.length;
            $("#boawards #img img").attr("src",tibibo.awards.icons[tibibo.awards.current.icon]);
        },
        state: function(_book, _state, _last) {
            var ret=[];
            for (var i in tibibo.awards.list) {
                var award = tibibo.awards.list[i];
                var count = [0,0,0,0,0]; // 5th is prev
                for (var j=0; j<4; j++) {
                    if (award.type[j]!=0) {
                        var node = _book.getnode(award.node[j]);
                        _book.each(node, function(_node) {
                            if (_state&&_state[_node.id]) {
                                if (award.type[j]==1) {
                                    count[j]+=  (_state[_node.id].match(/[\d]/g) || []).length;
                                }
                                else {
                                    count[j]+=  (_state[_node.id].match(/5/g) || []).length*3 +
                                                (_state[_node.id].match(/4/g) || []).length*2 +
                                                (_state[_node.id].match(/3/g) || []).length*1 ;
                                } 
                            }
                        });
                    }
                }
                if (_last && _last[i]) { count[4] = _last[i][4]; }
                ret.push(count);
            }
            return ret;
        },
        check: function(_update) {
            var ret = false;
            var state = tibibo.awards.state(tibibo.book.data.nav, tibibo.book.data.state, tibibo.book.data.awards);
            for (var i=0; i<tibibo.awards.list.length; i++) {
                var award   = tibibo.awards.list[i];
                var done=true;
                for (var j=0; j<4; j++) {
                    if (award.type[j]!=0) { if (state[i][j]<award.value[j]) { done=false; } }
                }
                if (done) {
                    if (state[i][4]==0) { ret = true; }
                    if (_update)        { state[i][4] = 1; tibibo.book.data.awards = state.slice(); }
                }
            }
            return ret;
        },
        up: function(_id) {
            if (_id>0) { tibibo.awards.list.splice(_id-1, 0, tibibo.awards.list.splice(_id, 1)[0]); }
            tibibo.awards.save();
        },
        del: function(_id) {
            tibibo.awards.list.splice(_id,1);
            tibibo.awards.save();
        },
        onselect: function() {
            for (var i=0; i<4; i++) {
                tibibo.awards.current.type[i] = $("#boawards #type"+(i+1)).val();
                tibibo.awards.current.node[i] = $("#boawards #chapter"+(i+1)).val();
                tibibo.awards.current.value[i]= $("#boawards #goal"+(i+1)+" input").val();
                var n=tibibo.book.data.nav.getnode(tibibo.awards.current.node[i]), ex=0;
                tibibo.book.data.nav.each(n, function(_node) {
                        if (_node.description) { ex+=_node.description.split(',').length; } });
                $("#boawards #max"+(i+1)).html(ex*(tibibo.awards.current.type[i]==2?3:1));
            }
            tibibo.awards.current.label = tibibo.helpers.cleantext($("#boawards textarea").val());
        },
        update: function(_elt) {
            if (_elt) { tibibo.awards.current=$.extend(true,{}, _elt); }
            else if (!tibibo.awards.current) {
                var n=tibibo.book.data.nav.root();
                tibibo.awards.current=$.extend(true,{node:[n,n,n,n]},tibibo.awards.init); }
            $("#boawards #img img").attr("src",tibibo.awards.icons[tibibo.awards.current.icon]);
            $("#boawards #img").css("background-color",tibibo.awards.colors[tibibo.awards.current.color]);
            $("#boawards textarea").val(tibibo.awards.current.label);
            for (var i=0; i<4; i++) {
                $("#boawards #type"+(i+1)).val(tibibo.awards.current.type[i]);
                $("#boawards #chapter"+(i+1)).val(tibibo.awards.current.node[i]);
                $("#boawards #goal"+(i+1)+" input").val(tibibo.awards.current.value[i]);
            }
            tibibo.awards.onselect();
        },
        insert: function() {
            tibibo.awards.onselect();
            if (tibibo.awards.selected==-1) {
                console.log("New award: "+JSON.stringify(tibibo.awards.current));
                tibibo.awards.list.push($.extend(true,{},tibibo.awards.current));
            }
            else {
                console.log("Upd award#"+tibibo.awards.selected+": "+JSON.stringify(tibibo.awards.current));
                tibibo.awards.list[tibibo.awards.selected]=$.extend(true,{},tibibo.awards.current);
            }
            $(".boawelt").removeClass("new");
            tibibo.awards.selected=-1;
            tibibo.awards.save();
        },
        save: function() {
			console.log("Save :"+JSON.stringify(tibibo.awards.list));
            user.getJSON("mods/tibibo/api/book.php",{ action:"upd", book:tibibo.args.id},
                {awards:JSON.stringify(tibibo.awards.list)}, function(_data){
				if (_data && _data.awards) {
					tibibo.awards.selected	= -1;
					tibibo.awards.list		= _data.awards;
				}
				tibibo.awards.display();
			});
        },
        display:function() {
            tibibo.book.data.awards =
                tibibo.awards.state(tibibo.book.data.nav, tibibo.book.data.state, tibibo.book.data.awards);
			if (tibibo.awards.pageid*10>=tibibo.awards.list.length) { tibibo.awards.pageid = 0; }
			
			// AWARDS
			$("#boawardscontent").html("");
            for (var i=tibibo.awards.pageid*10; i<Math.min(tibibo.awards.pageid*10+10,tibibo.awards.list.length); i++) {
                var award   = tibibo.awards.list[i];
                var $elt    = $("<div class='boawelt' id='a"+i+"'></div>");
                var $img    = $("<div class='img icon'></div>")
                              .css("background-color",tibibo.awards.colors[award.color]);
                var $label  = $("<div class='label'></div>");
                $elt.append($img);
                $elt.append($label);
                var $prog = $("<div class='progress'></div>");
                var nb=0, done=true, prev=(tibibo.book.data.awards[i][4]!=0);
                for (var j=0; j<4; j++) {
                    if (award.type[j]!=0) {
                        nb++;
                        var value = tibibo.book.data.awards[i][j];
                        var max   = award.value[j];
                        var $slider = $("<div class='slider' id='p"+award.node[j]+"'><div class='bar'></div>"+
                          "<div class='value'>"+
                          (value>=max?tibibo.locale.donelabel:value+"/"+max)+
                          "</div></div>");
                        $slider.append("<div class='icon'><img src='res/img/default/white/"+
                            (award.type[j]==1?"settings":"star")+".svg' alt=''/></div>");
							
						if (value<max) {
							$slider.bind("touchstart mousedown", function(_e) {
								tibibo.book.nodeid=$(this).attr("id").substr(1);
								tibibo.book.display();
								tibibo.awards.close();
								_e.preventDefault();
							});
						}
						
                        $slider.find(".bar").css("width",(100*Math.min(value,max)/max)+"%");
                        $prog.append($slider);
                        if (value<max) { done = false; }
                    }
                }
                
                var src="res/img/default/white/about.svg";
                if (done) {
                    if (prev) { src = tibibo.awards.icons[award.icon]; $elt.addClass("done"); }
                    if (tibibo.book.data.awards[i][4]==-1) { tibibo.book.data.awards[i][4] = 1; }
                }
                else { tibibo.book.data.awards[i][4] = 0; }
                
                if (user.islogged() && user.settings.devmode) { src = tibibo.awards.icons[award.icon]; }
                $img.append("<img src='"+src+"' alt=''/>");
                if (done && !prev) {
                    
                    $elt.append("<div class='fire1 icon g_anim12 g_anoloop'><div><img src='res/img/default/anim/star05.svg'/></div></div>");
                    $elt.append("<div class='fire2 icon g_anim12 g_anoloop'><div><img src='res/img/default/anim/star06.svg'/></div></div>");
            
                    $elt.addClass("new").bind("touchstart mousedown", function(_event) {
                        $(this).removeClass("new").addClass("done");
                        var id = $(this).attr("id").substr(1);
                        var award   = tibibo.awards.list[id];
                        $(this).find(".img img").attr("src", tibibo.awards.icons[award.icon])
                            .css("opacity",0).animate({opacity:1},1500);
                        tibibo.book.data.awards[id][4] = 1;
                        $(this).find(".g_anim12").show().find("div").addClass("g_arunning");
                        setTimeout(function(){
                            $("#boawards .g_anim12").hide().find("div").removeClass("g_arunning");
							
							$("#bomain #congrats")
								.html(tibibo.locale.congrats[Math.floor(Math.random()*tibibo.locale.congrats.length)])
								.css("left","100%").show()
								.animate({left:"30%"},400);
							setTimeout(function() {
								$("#bomain #congrats").animate({left:"100%"},400);
							}, 1000);
                        }, 1000);
						
                        $(this).unbind("touchstart mousedown");
                        _event.preventDefault();
                        _event.stopPropagation();
                    });
                }
                
                var label   = tibibo.helpers.format(award.label);
                $label.html(label);
                
                $elt.append($prog.addClass("n"+nb));
                
                if (user.islogged() && user.settings.devmode) {
                    var $edit = $("<div id='edit' class='icon'><img src='res/img/default/white/edit.svg' alt=''/></div>");
                    $elt.append($edit);
                    $edit.bind("touchstart mousedown", function(_event) {
                        $(".boawelt").removeClass("new");
                        $(this).parent().addClass("new");
                        tibibo.awards.selected = $(this).parent().attr("id").substr(1);
                        tibibo.awards.update(tibibo.awards.list[tibibo.awards.selected]);
                        _event.preventDefault();
                    });
                    
                    
                    var $left = $("<div id='move' class='icon'><img src='res/img/default/white/up.svg' alt=''/></div>");
                    $elt.append($left);
                    $left.bind("touchstart mousedown", function(_event) {
                        tibibo.awards.up($(this).parent().attr("id").substr(1));
                        _event.preventDefault();
                    });
                    
                    var $del = $("<div id='del' class='icon'><img src='res/img/default/white/delete.svg' alt=''/></div>");
                    $elt.append($del);
                    $del.bind("touchstart mousedown", function(_event) {
                        tibibo.awards.del($(this).parent().attr("id").substr(1));
                        _event.preventDefault();
                    });
                }
                
                $("#boawardscontent").append($elt);
            }
			
			// NAVIGATION
			$("#boawardsnav").html("");
			if (tibibo.awards.list.length>10) {
				var nbPages = Math.ceil(tibibo.awards.list.length/10);
				for (var i=0; i<nbPages; i++) {
					var $nav = $("<div id='nav"+i+"'>"+i+"</div>");
					if (i==tibibo.awards.pageid) { $nav.addClass("s"); }
					
                    $nav.bind("touchstart mousedown", function(_event) {
						tibibo.awards.pageid = $(this).attr("id").substr(3);
						tibibo.awards.display();
                        _event.preventDefault();
                    });
					$("#boawardsnav").append($nav);
				}
			}
			
        },
        close: function() { $("#boawards").hide();
        },
        open: function() {
            if (user.islogged() && user.settings.devmode) {
                $("#boawards #colors").html("");
                for( var i in tibibo.awards.colors) {
                    var $elt=$("<div id='c"+i+"' class='icon' style='background-color:"+tibibo.awards.colors[i]+"'></div>");
                    $elt.bind("mousedown touchstart",function(_e) {
                        tibibo.awards.color($(this).attr("id").substr(1));
                        _e.preventDefault();
                    });
                    $("#boawards #colors").append($elt);
                }
                
                var n = tibibo.book.data.nav.getnode(tibibo.book.data.nav.root());
                $("#boawards .chapter").html("");
                tibibo.book.data.nav.each(n, function(_node) {
                    $("#boawards .chapter").append("<option value='"+_node.id+"'>"+
                        tibibo.helpers.format(_node.label,"$1")+"</option>");
                });
                
                tibibo.awards.update();
                $("#boawardsedit").show();
                $("#boawardscontent").addClass("small");
            }
            else { $("#boawardsedit").hide(); $("#boawardscontent").removeClass("small"); }
            
            tibibo.awards.display();
            $("#boawards").css("opacity",0).show().animate({opacity:1},500);
        }
    },
	
	process: {
		shufflemode: false,
		onupdate:function(_state) {
			if (!user.settings.devmode) {
                if (!tibibo.book.data.state) { tibibo.book.data.state={}; }
                tibibo.book.data.state[tibibo.book.nodeid] = _state;
                if (user.islogged()) {
                    user.getJSON("mods/tibibo/api/tibibo.php",
                        { action:"upd",value:_state, book:tibibo.args.id, id:tibibo.book.nodeid}, "",
                            function(_data) { }); }
				tibibo.book.progress();
			}
		},
		launch: function(_args, _shuffle) {
			tibibo.process.shufflemode = _shuffle;
			$("#waiting").show().find("div").addClass("g_arunning");
            $("#activity").jlodb({
                standalone: tibibo.standalone,
                onstart:    function($this) {
                    if ($("#bopage").is(":visible")) {
                        $this.parent().css("opacity",0)
                             .animate({opacity:1},500, function() { $("#bopage").hide(); }).show();
                    }
                    $("#waiting").hide().find("div").removeClass("g_arunning"); },
                onfinish:   function($this, _hide) {
                    if (_hide) { $this.parent().hide(); $("#bopage").show(); }
                    $("#g_score").score('hide'); },
                onscore:    function($this, _ret) {
                    var isnext = false;
                    if (_ret.score>=2) {
						if (tibibo.process.shufflemode) {
							var s = tibibo.book.data.state[tibibo.book.nodeid];
							var p = s.indexOf(".");
							s = s.substr(0, p)+_ret.score.toString()+s.substr(p+1);
							if (p<s.length-1) { s = s.substr(0, p+1)+"."+s.substr(p+2); }
							tibibo.process.onupdate(s);
							isnext = (tibibo.process.shuffle.next()!=0);
						}
						else { isnext = $("#boframe").menu('score', _ret.score).menu('more'); }
					}
                    $("#g_score #g_snext").toggle(isnext);
                    $("#g_score").score('show',_ret.score);
                    $("##g_scoreaward").toggle(tibibo.awards.check());
                    return true; } },_args);
		},
		shuffle: {
			next: function() {
				var ret = 0, exs=[];
				for (var i in tibibo.book.data.state) {
					var s  = tibibo.book.data.state[i];
					var ex = s.indexOf(".");
					if (ex!=-1 && tibibo.book.data.nav.getnode(i)) {
						exs.push([i, tibibo.book.data.nav.getnode(i).description.split(",")[ex]]);
					}
				}
				return exs.length?exs[Math.floor(Math.random()*exs.length)]:0;
			},
			run: function() {
				var x=tibibo.process.shuffle.next();
				if (x) {
					tibibo.book.nodeid = x[0];
					tibibo.process.launch({id: x[1]}, true);
				}
			}
		}
	},
    
    menu:function(_list) {
        var state = "";
        if (tibibo.book.data.state) { state = tibibo.book.data.state[tibibo.book.nodeid]; }
        if (!state) { state="."; }
        for (var i=state.length; i<_list.length; i++) { state+=user.islogged()?"l":"."; }
        if (user.settings.devmode) { state = ""; for (var i=0; i<_list.length; i++) { state+="."; } }

        $("#boframe").html("").menu({
            large   : 8,
            list    : _list,
            state   : state,
            onupdate: function($this, _state) { tibibo.process.onupdate(_state); },
            onclick : function($this, _args)  { tibibo.process.launch(_args); }
        });
    },
    node : {
        icon: function(_elt, _args) {
            if (!_args) { _args = {}; }

            var $elt = $("<div id='n"+_elt.id+"' class='node'></div>");
            if (!_args.noclick)   {
                $elt.bind("touchstart mousedown", function(e) { tibibo.node.click($(this)); e.preventDefault(); });
            }
                
            $elt.append("<div class='icon'><img src='"+(_elt.id==-1?"mods/tibibo/icon.svg":_elt.src)+"'/></div>");
                
            if (_args.progress) {
                var $progress = $("<div class='progress usermode'>"+
                    "<div style='width:"+(_args.progress[1]?_args.progress[0]/_args.progress[1]:1)+"em';>"+"</div></div>");
                $elt.append($progress);
            }
            
            if (_args.id) { $elt.append("<div class='id'>"+_elt.id+"</div>"); }
                
            if (_elt.nbstar>0) {
                $elt.addClass("s");
                var $stars  = $("<div class='star'>"+
                    "<img src='res/img/default/icon/menu01st"+(_elt.nbstar-1)+".svg'/></div>");
                $elt.append($stars);
            }

            if (_args.label) { $elt.append("<div class='label'>"+tibibo.helpers.format(_elt.label)+"</div>"); }
            if (_args.done && _args.progress && _args.progress[0]==_args.progress[1]) {
                    $elt.append("<div class='done'>"+tibibo.locale.donelabel+"</div>"); }
                    
            $elt.append("<div class='mask'></div>");

            return $elt;
        },
        interactive : true,
        click: function($node) {
            if (tibibo.node.interactive) {
                var id  = $node.attr("id").substr(1);
                var elt = tibibo.book.data.nav.getnode(id);
                var upd = true;
                var rem = true;
                var sav = false;
                var tra = false;
            
                console.log("+ click on node #"+id);
                if (!elt) { console.log("  - node not found"); return; }
                
                switch($("#bofooter .s").attr("id")) {
                    case "mdelete"  : tibibo.book.data.nav.del(id); sav = true; break;
                    case "mleft"    : tibibo.book.data.nav.left(id);  sav = true; rem = false; break;
                    case "mright"   : tibibo.book.data.nav.right(id); sav = true; rem = false; break;
                    case "medit"    : if (id!=-1) { tibibo.node.edit.open(elt); } upd =false; break;
					case "mmove"	: tibibo.book.pdata.id=id; $("#mmove>div").html(id); rem = true; upd = false; break;
                    default: tibibo.book.nodeid = id; tra = true; break;
                }
                if (rem) { $("#bofooter .s").removeClass("s"); }
                if (sav) { tibibo.book.save(); }
                
                if (upd) {
                    if (tra) {
                        tibibo.node.interactive = false;
                        $node.find(".mask").css("opacity",0).animate({opacity:1}, 200, function() {
                            $("#boframe").animate({opacity:0},500, function() {
                                tibibo.book.display();
                                $("#boframe").animate({opacity:1},500, function() {
                                    tibibo.node.interactive = true;
                                });
                            });
                        });
                    }
                    else { tibibo.book.display(); }
                }
            }
        
            return;
        },
        edit: {
            star : 0,
            elt : 0,
            open: function(_elt) {
                $("#eedit #tibibi").show();
                if (_elt) {
                    // MODIFICATION
                    $("#nodeimg .icon img").attr("src",_elt.src);
                    $("#boeditnode #elabel").val(_elt.label);
					$("#boeditnode #ecomment").val(_elt.comment);
					$("#boeditnode #etibibi").val(_elt.description);
                    tibibo.node.edit.star = _elt.nbstar;
                    tibibo.node.edit.elt = _elt;
                    if (_elt.children.length) { $("#eedit #tibibi").hide(); }
                }
                else {
                    // CREATION
                    $("#nodeimg .icon img").attr("src","res/img/classification/root.svg");
                    $("#boeditnode #elabel").val("").attr("placeholder",tibibo.locale.default.elabel);
                    $("#boeditnode #ecomment").val("").attr("placeholder",tibibo.locale.default.ecomment);
                    $("#boeditnode #etibibi").val("").attr("placeholder",tibibo.locale.default.etibibi);
                    tibibo.node.edit.star = 0;
                    tibibo.node.edit.elt = 0;
                }
                tibibo.node.edit.refresh(false);
                $("#boeditnode #eedit").css("left","-20em").css("opacity",0).animate({left:"2em",opacity:1}, 1000 );
                $("#boeditnode #eimg").css("left","38em").css("opacity",0).animate({left:"23em",opacity:1}, 1000 );
                $("#boeditnode").show();
            },
            tibibi: function() {
                if ($("#boeditnode #tibibi select").val().length) {
                    user.getJSON("mods/tibibi/api/course.php",{value:$("#boeditnode #tibibi select").val()}, "",
                    function(_data) {
                        if (_data && _data.status=="success" && _data.description && _data.description.length>0) {
                            var val = $("#boeditnode #etibibi").val();
                            if (val.length) { val+=','; }
                            val += _data.description;
                            $("#boeditnode #etibibi").val(val);
                            tibibo.node.edit.refresh(false);
                        }
                    });
                }
            },
            refresh: function(_incstar) {
                if (_incstar) { tibibo.node.edit.star = (tibibo.node.edit.star+1)%5; }

                if (tibibo.node.edit.star!=0) {
                    $("#boeditnode .node .star img").attr("src", "res/img/default/icon/menu01st"+(tibibo.node.edit.star-1)+".svg");
                }
                
                $("#boeditnode .node").toggleClass("s", (tibibo.node.edit.star!=0));
                $("#boeditnode .node").toggleClass("f", 
                    ($("#boeditnode #tibibi textarea").val().length==0));
            },
            valid: function() {
                var label = tibibo.helpers.cleantext($("#boeditnode #elabel").val());
                var comment = tibibo.helpers.cleantext($("#boeditnode #ecomment").val());
                var desc = $("#boeditnode #etibibi").val();
                
                if (tibibo.node.edit.elt) {
                    tibibo.node.edit.elt.src            = $("#nodeimg .icon img").attr("src");
                    tibibo.node.edit.elt.nbstar         = tibibo.node.edit.star;
                    tibibo.node.edit.elt.label          = label;
                    tibibo.node.edit.elt.comment        = comment;
                    tibibo.node.edit.elt.description    = desc;
                }
                else {
                    var elt={
                        id          : tibibo.book.data.nav.getmaxid()+1,
                        src         : $("#nodeimg .icon img").attr("src"),
                        nbstar      : tibibo.node.edit.star,
                        label       : label,
                        comment     : comment,
                        description : desc,
                        children    : []
                    };

                    var node = tibibo.book.data.nav.getnode(tibibo.book.nodeid);
                    node.children.push(elt);
                }
                tibibo.book.save();
                tibibo.book.display();
                tibibo.node.edit.close();
            },
            close: function() {
                $("#boeditnode>div").animate({opacity:0}, 1000, function() { $("#boeditnode").hide(); } );
            }
        }
    },
    book: {
        data    : { nav : 0, ownerkey : 0, value : "", state:{}, awards:[] },
		pdata	: { id: -1 },
        nodeid  : -1,
        open: function(_id) {
            console.log("==== open book: "+_id+" ====");
            document.location = "tibibo.html?id="+_id;
        },
		paste:function() {
			var iss = $("#bofooter #mmove").hasClass("s");
			$("#bofooter #oactions .action").removeClass("s");
			if (this.pdata.id==-1) {
				$("#bofooter #mmove").toggleClass("s",!iss);
				if (!iss) { $("#bofooter #mmove>div").html("^X"); }
			}
			else {
				var node = tibibo.book.data.nav.getnode(this.pdata.id);
				var loop = false;
				tibibo.book.data.nav.each(node, function(_node) {
					if (_node.id == tibibo.book.nodeid) { loop = true; }
				});
				if (loop) { alert("ERROR: paste operation not authorized"); }
				else {
					tibibo.book.data.nav.del(this.pdata.id);
					var target = tibibo.book.data.nav.getnode(tibibo.book.nodeid);
					target.children.push(node);
					tibibo.book.save();
					tibibo.book.display();
				}
				
				$("#bofooter #mmove>div").html("^X");
				this.pdata.id = -1;
			}
		},
        chapter: function(_id) {
            tibibo.book.nodeid = _id;
            tibibo.book.display();
        },
        create: function(_value) {
            _value=tibibo.helpers.cleantext(_value);
            console.log("==== create new book: "+_value+" ====");
        
            user.getJSON("mods/tibibo/api/book.php",{action:"new",value:encodeURIComponent(_value)}, "",
                function(_data) {
                    if (_data.status=="success") { tibibo.book.open(_data.value); }
                    else { $("#boerror").html(_data.error+" : "+_data.textStatus).show(); }
                });
        },
		progress: function() {
			var n = tibibo.book.data.nav.getnode(tibibo.book.data.nav.root()), prog=[0,0];
            tibibo.book.data.nav.each(n, function(_node) {
                if (_node.description.length) { prog[1]+=_node.description.split(',').length; }
                    if (tibibo.book.data.state && tibibo.book.data.state[_node.id]) {
                        prog[0]+=(tibibo.book.data.state[_node.id].match(/[\d]/g) || []).length;
                }
            });
            $("#olist .slide").css("top",(1-(prog[0]/prog[1]))+"em");
            $("#olist .value").html(Math.floor(100*prog[0]/prog[1]));
            $("#bofooter #olist").show();
		},
        display: function() {
            $("#boframe").html(""); $("#bonav").html("");
            var node = tibibo.book.data.nav.getnode(tibibo.book.nodeid);
            if (!node) {
                tibibo.book.nodeid = tibibo.book.data.nav.root();
                node = tibibo.book.data.nav.getnode(tibibo.book.nodeid);
            }
            console.log("+ display node: "+(node.id)+" - nbelts: "+(node.children.length));
            
            // NAVIGATION IN HEADER
            var $label;
            if (tibibo.book.nodeid==-1) {
                if (user.settings.devmode) {
                    $label=$("<textarea class='label ex' autocomplete='off' autocorrect='off' autocapitalize='off' spellcheck='false'></textarea>");
                    $label.val(tibibo.book.data.value);
                    $label.bind("focusout",function() {
                        user.getJSON("mods/tibibo/api/book.php",
                            {action:"upd",book:tibibo.args.id,value:$("#bonav textarea").val()}, {},
                            function(_data) {});
                    });
                }
                else { $label=$("<div class='label ex'>"+tibibo.helpers.format(tibibo.book.data.value)+"</div>"); }
            }
            else { $label=$("<div class='label'>"+tibibo.helpers.format(node.label)+"</div>"); }
            $("#bonav").append($label);
            var parents = tibibo.book.data.nav.getparents(tibibo.book.nodeid);
            for (var i=parents.length; i>0; i--) {
                $("#bonav").append(tibibo.node.icon(tibibo.book.data.nav.getnode(parents[i-1])));
            }
            
            // CONTENT IN MAIN FRAME
            if (node.children.length) {
                for (var i in node.children) {
                    var n = node.children[i], prog=[0,0];
                    tibibo.book.data.nav.each(n, function(_node) {
                        if (_node.description.length) { prog[1]+=_node.description.split(',').length; }
                        if (tibibo.book.data.state && tibibo.book.data.state[_node.id]) {
                            prog[0]+=(tibibo.book.data.state[_node.id].match(/[\d]/g) || []).length;
                        }
                    });
                    var args={ label:true, done:true, progress:((user.settings.devmode)?0:prog),
                               id:user.settings.devmode}
                    $("#boframe").append(tibibo.node.icon(node.children[i], args));
                }
            }
            else if (node.description.length) { tibibo.menu(node.description.split(",")); }
            
            
            // FOOTER CONTENT
            $("#bofooter>div").hide();
			$("#bofooter #oshuffle").toggleClass("d",!tibibo.process.shuffle.next()).show();
           
			
			// NO FULLSCREEN NOR QUIT BUTTON ON ANDROID EXPORT
			if (tibibo.platform=="default" && tibibo.book.nodeid == tibibo.book.data.nav.root() ) {
				$("#bofooter #oquit").show();
			}
			if (tibibo.platform!="android") { $("#bofooter #ofullscreen").show(); }
			
            if (user.islogged() && user.settings.devmode ) {
                if (tibibo.book.data.ownerkey==user.settings.key && !node.description.length) {
                    $("#bofooter #oactions").show();
                }
            }
            
            tibibo.book.progress();
            
            $("#boframe").show();
            $("#bohome").detach();
        },
        save: function() {
            console.log("+ tibibo book ("+tibibo.args.id+") save on database");
            var root = tibibo.book.data.nav.getnode(tibibo.book.data.nav.root());
            user.getJSON("mods/tibibo/api/book.php",
                {action:"upd",book:tibibo.args.id}, {description:JSON.stringify(root.children)},
                function(_data) {});
        }
    },
    init: function() {
        console.log("==== tibibo.init ====");
        console.log(JSON.stringify(user.settings));
        $("#bocontent>div").hide();
        $("#omenu .icon").removeClass("s");
        if (user.settings && user.settings.devmode) { $("#bomain").addClass("devmode"); }
        else                                        { $("#bomain").removeClass("devmode"); }
        
        // A BOOK IS REQUIRED
        if (tibibo.args.id) {
            console.log("+ asking book "+tibibo.args.id);
            user.getJSON("mods/tibibo/api/book.php", {value:tibibo.args.id}, 0, function(_data) {
                if (_data.error) {
                    console.log("  - not found");
                    $("#boerror").html(tibibo.locale.error.booknotfound.replace("$1",tibibo.args.id)).show();
                    tibibo.args.id = 0;
                    tibibo.init();
                }
                else {
                    tibibo.book.data = {
                        nav        : tibibo.helpers.nav(_data.description),
                        ownerkey   : _data.ownerkey,
                        value      : _data.value
                    };
                    tibibo.book.nodeid = tibibo.args.chapter?tibibo.args.chapter:tibibo.book.data.nav.root();
                    tibibo.awards.list = _data.awards?_data.awards:[];

                    // GET THE COURSE LIST FROM TIBIBI TO FILL NODE IN DEVMODE
                    if (user.islogged()) {
                        $("#tibibi select").html("");
                        user.getJSON("mods/tibibi/api/course.php",{action:"list"}, "",function(_data) {
                            if (_data) for (var i in _data.courses) {
                                $("#tibibi select").append("<option>"+_data.courses[i]+"</option>"); }
                        });
                    }
                    
                    if (user.islogged() && !user.settings.devmode) {
                        user.getJSON("mods/tibibo/api/tibibo.php", {action:"all",book:tibibo.args.id },0,
                            function(_data) {
                                tibibo.book.data.state = _data.state;
                                tibibo.book.display();
                                tibibo.awards.check(true);
                        });
                    }
                    else { tibibo.book.display(); }
                    
                }
            });
        }
        // SHOW BOOK LIST
        if (!tibibo.args.id) {
            $("#bohome .list").html("");
            $("#bofooter>div").hide();
            if (user.islogged()) {
                user.getJSON("mods/tibibo/api/"+(user.settings.devmode?"book.php":"tibibo.php"),
                             {action:"list"},0, function(_data) {
                    for (var i in _data.books) {
                        var $elt=$("<div id='"+_data.books[i].id+"'></div>");
                        $elt.append("<div class='bookid'>"+_data.books[i].id+"</div>");
                        $elt.append("<div class='label'>"+_data.books[i].label+"</div></div>");
                        $elt.bind("touchstart mousedown",function(event) {
                            if ( user.settings.devmode && $("#bofooter #odelete").hasClass("s")) {
                                var value=$(this).attr("id");
                                console.log("+ remove book "+value);
                                user.getJSON("mods/tibibo/api/book.php",{action:"del", value:value},0,
                                    function(_data) { document.location="tibibo.html"; });
                            }
                            else { tibibo.book.open($(this).find(".bookid").text()); }
                            
                            event.preventDefault();
                        });
                        $("#bohome .list").append($elt);
                    }
                });
                $("#bofooter #odelete").removeClass("s");
                if (user.settings.devmode) { $("#bofooter #odelete").show(); }
            }
            $("#bohome").show();
        }
    }
};


$(window).ready(function() {
    // GET URL ARGUMENTS
    // id       : tibibo book id
    // chapter  : tibibo book chapter id
    var a = location.search.substring(1).split('&');
    for (var i in a) { var p= a[i].split('='); tibibo.args[p[0]]=p[1]; }
    
	$(window).resize(); setTimeout(function() { $(window).resize(); }, 1000);
	
	$.ajaxSetup({ mimeType: "text/plain" });
	$("#bomain").show();

    if (tibibo.standalone) {
		tibibo.args.id=tibibo.bookname;
		
		$("#bolabel").html("Pouf-Pouf Production ["+tibibo.bookname+"-"+tibibo.version+"]");
		$("#bosplash").show();
		setTimeout(function() { $("#bosplash").animate({opacity:0}, 1000, function() { $(this).hide(); } ) }, 2000);
		
        // LOCALISATION
        $.getJSON("standalone/locale.json", function(_locale) {
            for (var i in _locale.locale) { $("#"+i).html(_locale.locale[i]); }
            tibibo.locale = _locale;
            
            // LOCALE VERSION
            user.load.logpanel($("#bomain"), {close:true}, function() { user.init(); });
        });
        
        user.getJSON = function(_url, _args, _post, _cbk, _alert) {
            console.log("+ standalone getJSON: "+_url+" - "+JSON.stringify(_args));
            if (_url.indexOf("book.php")!=-1) {
                $.getJSON("standalone/content.json", function(_data) { _cbk(_data); });
            }
            else if (_url.indexOf("tibibo.php")!=-1) {
                switch(_args.action) {
                    case "upd" :
                        console.log("+ save "+tibibo.args.id+user.settings.id+" state");
                        console.log(JSON.stringify(tibibo.book.data.state));
						if (tibibo.savemode=="local") {
							localStorage.setItem(tibibo.args.id+user.settings.id, JSON.stringify(tibibo.book.data.state));
						}
						else {
							$.cookie(tibibo.args.id+user.settings.id, JSON.stringify(tibibo.book.data.state), { expires : 365 });
						}
                        _cbk(0);
                    break;
                    default :
                        console.log("+ load "+tibibo.args.id+user.settings.id+" state");
						var state;
						if (tibibo.savemode=="local") {
							state = localStorage.getItem(tibibo.args.id+user.settings.id);
						}
						else {
							state = $.cookie(tibibo.args.id+user.settings.id);
						}
                        console.log(state);
                        _cbk({state:state?JSON.parse(state):{}});
                    break;
                }
            }
            else { _cbk(0); }
        }
    }
    else {
        // CLIENT VERSION
        $.getJSON("api/checkdb.php", function (_check) {

            if (_check.status=="success") {
                // GLOBAL DATA
                tibibo.lang=_check.lang;
                tibibo.url =_check.url;

                // USER HANDLER INITIALISATION
                user.load.edit($("#bomain"));
                user.load.devmode($("#bomain"));
                user.load.logpanel($("#bomain"), {close:true}, function() { user.init(tibibo.lang); });
                
                // LOCALISATION
                $.getJSON("mods/tibibo/locale/"+_check.lang+"/text.json?debug="+Math.floor(Math.random()*1000), function(_locale) {
                    for (var i in _locale.locale) { $("#"+i).html(_locale.locale[i]); }
                    for (var i in _locale.input) { $("#"+i).val(_locale.input[i]); }
                    tibibo.locale = _locale;
                });

            }
            else {
                $("#bomain").html(_check.status+": "+_check.textStatus);
            }
        });

        // HANDLE ICON
        var icons = [
        "res/img/activity/abacus.svg", "res/img/activity/alchemist.svg","res/img/activity/asm.svg","res/img/activity/balance.svg","res/img/activity/board.svg","res/img/activity/cards.svg","res/img/activity/code.svg","res/img/activity/correcter.svg","res/img/activity/countdown.svg","res/img/activity/crossword.svg","res/img/activity/equation.svg","res/img/activity/geometry.svg","res/img/activity/hammer.svg","res/img/activity/info.svg","res/img/activity/jewel.svg","res/img/activity/launch.svg","res/img/activity/logo.svg","res/img/activity/mahjong.svg","res/img/activity/marker.svg","res/img/activity/mathcraft.svg","res/img/activity/memory.svg","res/img/activity/memory2.svg","res/img/activity/memory3.svg","res/img/activity/novel.svg","res/img/activity/operation.svg","res/img/activity/paint.svg","res/img/activity/puzzle.svg","res/img/activity/quizz.svg","res/img/activity/robot.svg","res/img/activity/sequence.svg","res/img/activity/shop.svg","res/img/activity/sokoban.svg","res/img/activity/sorting.svg","res/img/activity/sudoku.svg","res/img/activity/toggleswitch.svg","res/img/activity/trafficjam.svg","res/img/activity/where.svg","res/img/activity/wordmix.svg","res/img/classification/addition.svg","res/img/classification/animal.svg","res/img/classification/arithmetic.svg","res/img/classification/arts.svg","res/img/classification/division.svg","res/img/classification/french.svg","res/img/classification/game.svg","res/img/classification/geography.svg","res/img/classification/geometry.svg","res/img/classification/grammar.svg","res/img/classification/gravity.svg","res/img/classification/health.svg","res/img/classification/it.svg","res/img/classification/languages.svg","res/img/classification/logic.svg","res/img/classification/mathematics.svg","res/img/classification/measure.svg","res/img/classification/money.svg","res/img/classification/multiplication.svg","res/img/classification/negative.svg","res/img/classification/numeration.svg","res/img/classification/observation.svg","res/img/classification/operations.svg","res/img/classification/physics.svg","res/img/classification/reading.svg","res/img/classification/reflexion.svg","res/img/classification/root.svg","res/img/classification/sciences.svg","res/img/classification/social.svg","res/img/classification/subtraction.svg","res/img/classification/symmetry.svg","res/img/classification/technology.svg","res/img/classification/time.svg","res/img/classification/vegetable.svg","res/img/classification/word.svg","mods/tibibo/res/img/thumbnail/bear01.svg","mods/tibibo/res/img/thumbnail/bunny01.svg","mods/tibibo/res/img/thumbnail/pinguin01.svg","mods/tibibo/res/img/thumbnail/pig01.svg"
        ];
        
        $("#eimg").html("");
        for (var i in icons) {
            var $icon=$("<div class='icon'><img src='"+icons[i]+"' alt=''/></div>");
            $icon.bind("mousedown touchstart", function(event) {
                $("#nodeimg .icon img").attr("src", $(this).children().first().attr("src"));
                event.preventDefault();
            });
            $("#eimg").append($icon);
        }
        
    }
    
    $("#g_score").score({
        onreload:function($this) { $('#activity').jlodb('reload'); },
        onmenu:  function($this) { $('#activity').jlodb('close', true); 
                                tibibo.book.display(); },
        onnext:  function($this) {
			$('#activity').jlodb('close',false);
			if (tibibo.process.shufflemode) { tibibo.process.shuffle.run(); }
			else 							{ $('#boframe').menu('next'); }
		} 
    });
    
    var $award = $("<div id='scoreaward' class='icon'><img src='res/img/default/white/award.svg' alt=''/></div>").insertAfter("#g_score #fire3").bind("touchstart mousedown", function(_event) {
        $("#g_score").hide();
        $(".jlodb").hide();
		tibibo.book.display();
        $("#bopage").show();
        tibibo.awards.open();
        _event.preventDefault();
    });

});
    </script>
</head>

<body>
{% include 'templates/widget_back_menu.html' %}

    <div id="bomain">

      <div id="bopage">
        <div id="boheader" class="topdown">

            <!-- NAVIGATION ICONS AND CHAPTER/BOOK DESCRIPTION -->
            <div id="bonav"></div>

            <!-- USER PROFILE -->
            <div id="profile">
                <div id="avatar"  ontouchstart="tibibo.user();event.preventDefault();"
                     class="icon" onclick="tibibo.user();"></div>
                <div id="label">
                    <div id="name">&nbsp;</div>
                    <div id="sub"></div>
                    <div id="edmode" class="icon" ontouchstart="tibibo.helpers.devmode();event.preventDefault();"
                        onclick="tibibo.helpers.devmode();"><img src="res/img/default/white/edit.svg"/></div>
                </div>
                <div id="out" class="icon" ontouchstart="user.logout($(this));event.preventDefault();"
                    onclick="user.logout($(this));"><img src="res/img/default/white/logout.svg"/></div>
            </div>

        </div>

        <!-- PAGE CONTENT -->
        <div id="bocontent">

            <!-- MAIN FRAME -->
            <div id="boframe"></div>

            <!-- FRONT PAGE -->
            <div id="bohome">
                <div class="input redline">
                    <div class="usermode">
						<form action="javascript:tibibo.book.open($('#bocinput').val())">
							<div id="clabel" class="label"></div>
							<input id="bocinput"></input>
							<div class="icon" onmousedown="$(this).parent().submit()"
								 ontouchstart="$(this).parent().submit();event.preventDefault()">
								<img src="res/img/default/white/valid.svg"/>
							</div>
							<input type="submit" style="display:none;"/>
						</form>
                    </div>
                    <div class="devmode">
						<form action="javascript:tibibo.book.create($('#bodinput').val())">
							<div id="dlabel" class="label"></div>
							<input id="bodinput"></input>
							<div class="icon" onmousedown="$(this).parent().submit();"
								 ontouchstart="$(this).parent().submit();event.preventDefault();">
								<img src="res/img/default/white/valid.svg"/>
							</div>
							<input type="submit" style="display:none;"/>
						</form>
                    </div>
                </div>
                <div class="booklist">
                    <div class="title"></div>
                    <div class="list"></div>
                </div>
            </div>

        </div>
        
        <!-- AWARDS PAGE-->
        <div id="boawards"  >
        <div>
			<div id="boawardstitle" style="font-size:0.8em">
				<div class="icon" style="background-color:white;float:left;cursor:pointer"
					onmousedown="$(this).closest('#boawards').hide();"
					ontouchstart="$(this).closest('#boawards').hide();event.preventDefault();" >
                    <img src="res/img/default/icon/nw_back01.svg" alt=""/></div>
				<div id="lawards" style="text-align:center;font-size:.8em;font-style:italic;color:#555;background-color:white;"></div>
			</div>
            <div id="boawardsedit">
                <div class="icon" id="img" onmousedown="tibibo.awards.icon();"
                    ontouchstart="tibibo.awards.icon();event.preventDefault();">
                    <img src="res/img/svginventoryicons/pencil/brush01.svg" alt=""/></div>
                <div id="colors"></div>
                <textarea id="description" autocomplete='off' autocorrect='off' autocapitalize='off' spellcheck='false'></textarea>
                <div id="goals">
                    <div id="goal1" class="goal">
                        <select id="chapter1" class="chapter" onchange="tibibo.awards.onselect()"></select>
                        <select id="type1" onchange="tibibo.awards.onselect()">
                            <option value="0">None</option>
                            <option value="1">Exercices</option>
                            <option value="2">Stars</option>
                        </select>
                        <input onchange="tibibo.awards.onselect()"/>
                        <div id="max1" class="max">xx</div>
                    </div>
                    <div id="goal2" class="goal">
                        <select id="chapter2" class="chapter" onchange="tibibo.awards.onselect()"></select>
                        <select id="type2" onchange="tibibo.awards.onselect()">
                            <option value="0">None</option>
                            <option value="1">Exercices</option>
                            <option value="2">Stars</option>
                        </select>
                        <input onchange="tibibo.awards.onselect()"/>
                        <div id="max2" class="max">xx</div>
                    </div>
                    <div id="goal3" class="goal">
                        <select id="chapter3" class="chapter" onchange="tibibo.awards.onselect()"></select>
                        <select id="type3" onchange="tibibo.awards.onselect()">
                            <option value="0">None</option>
                            <option value="1">Exercices</option>
                            <option value="2">Stars</option>
                        </select>
                        <input onchange="tibibo.awards.onselect()"/>
                        <div id="max3" class="max">xx</div>
                    </div>
                    <div id="goal4" class="goal">
                        <select id="chapter4" class="chapter" onchange="tibibo.awards.onselect()"></select>
                        <select id="type4" onchange="tibibo.awards.onselect()">
                            <option value="0">None</option>
                            <option value="1">Exercices</option>
                            <option value="2">Stars</option>
                        </select>
                        <input onchange="tibibo.awards.onselect()"/>
                        <div id="max4" class="max">xx</div>
                    </div>
                </div>
                <div class="icon" id="add" onmousedown="tibibo.awards.insert();"
                    ontouchstart="tibibo.awards.icon();event.preventDefault();">
                    <img src="res/img/default/white/add.svg" alt=""/></div>
                 
            </div>
            <div id="boawardscontent"></div>
			<div id="boawardsnav"></div>
        </div>
        
        </div>

        <!-- ERROR LOG PANEL (WRONG BOOK ID)-->
        <div id="boerror" class="redline"></div>

 
        <div id="bofooter" class="topdown">
        
            <!-- FOOTER UTILS -->
			
			
            <div class="icon" id="ofullscreen" onmousedown="tibibo.fullscreen();"
                 ontouchstart="tibibo.fullscreen();event.preventDefault();" >
                 <img src="res/img/default/white/screen.svg"/></div>
				 
			<div class="icon" id="oquit" onmousedown="$('#boquitpanel').show();"
                 ontouchstart="$('#boquitpanel').show();event.preventDefault();" >
                 <img src="res/img/default/icon/cancel01.svg"/></div>
            
            <div id="odelete" class="icon action"
                onmousedown="$(this).toggleClass('s');"
                ontouchstart="$(this).toggleClass('s');event.preventDefault();" >
                <img src="res/img/default/white/delete.svg"/></div>
            
            <div id="olist" onmousedown="tibibo.awards.open();"
                    ontouchstart="tibibo.awards.open();event.preventDefault();">
                <div class="slide"></div>
                <div class="value">0</div>
            </div>
			
			<div id="oshuffle" onmousedown="if (!$(this).hasClass('d')) { tibibo.process.shuffle.run();}"
                    ontouchstart="if (!$(this).hasClass('d')) { tibibo.process.shuffle.run();} event.preventDefault();">
				<img src="res/img/default/white/run.svg" alt=""/></div>
                 
            <div id="oactions">
                <div class="icon action" onmousedown="tibibo.node.edit.open();"
                    ontouchstart="tibibo.node.edit.open();event.preventDefault();" >
                    <img src="res/img/default/white/newcourse.svg"/></div>
                <div id="mdelete" class="icon action"
                    onmousedown="$(this).toggleClass('s').siblings().removeClass('s');"
                    ontouchstart="$(this).toggleClass('s').siblings().removeClass('s');event.preventDefault();" >
                    <img src="res/img/default/white/delete.svg"/></div>
                <div id="medit" class="icon action"
                    onmousedown="$(this).toggleClass('s').siblings().removeClass('s');"
                    ontouchstart="$(this).toggleClass('s').siblings().removeClass('s');event.preventDefault();" >
                    <img src="res/img/default/white/edit.svg"/></div>
                <div id="mleft" class="icon action"
                    onmousedown="$(this).toggleClass('s').siblings().removeClass('s');"
                    ontouchstart="$(this).toggleClass('s').siblings().removeClass('s');event.preventDefault();" >
                    <img src="mods/tibibo/res/img/left.svg"/></div>
                <div id="mright" class="icon action"
                    onmousedown="$(this).toggleClass('s').siblings().removeClass('s');"
                    ontouchstart="$(this).toggleClass('s').siblings().removeClass('s');event.preventDefault();" >
                    <img src="mods/tibibo/res/img/right.svg"/></div>
                <div id="mmove" class="icon action" onmousedown="tibibo.book.paste();"
                    ontouchstart="tibibo.book.paste();event.preventDefault();" ><div>^X</div></div>
					
                    <!--
                <div id="mexport" class="icon action"
                    onmousedown="$(this).toggleClass('s').siblings().removeClass('s');"
                    ontouchstart="$(this).toggleClass('s').siblings().removeClass('s');event.preventDefault();" >
                    <img src="res/img/default/white/export.svg"/></div>
                <div id="mimport" class="icon action"
                    onmousedown="$(this).toggleClass('s').siblings().removeClass('s');"
                    ontouchstart="$(this).toggleClass('s').siblings().removeClass('s');event.preventDefault();" >
                    <img src="res/img/default/white/import.svg"/></div>
                    -->
            </div>
            

           
            
        </div>
    </div>
	
	<div id="congrats"></div>
    
    <div id="waiting" class="g_anim12"><div><img src="res/img/default/anim/waiting_red.svg"/></div></div>
    <div id="g_score"></div>
 
    <div class="jlodb">
        <div id="g_quit" ontouchstart="$('#activity').jlodb('quit');event.preventDefault();"
                       onclick="$('#activity').jlodb('quit');">
            <img src="res/img/default/icon/nw_quit01.svg"/></div>
        <div id="activity"></div>
    </div>
	
	<div id="boquitpanel"><div>
		<div id="boquitask"></div>
		<div class="icon" id="boquitcancel" onmousedown="$('#boquitpanel').hide();"
                 ontouchstart="$('#boquitpanel').hide();event.preventDefault();"><img src="res/img/default/icon/cancel01.svg"/></div>
		<div class="icon" id="boquitvalid" onclick="tibibo.close();" 
            ontouchstart="tibibo.close();event.preventDefault();">
			<img src="res/img/default/icon/valid01.svg"/></div>
	</div></div>

    <!-- EDITION PANEL -->
    <div id="boeditnode">
      <div id="eedit">
        <div id="settings">
            <div id="nodeimg" class="node" onclick="tibibo.node.edit.refresh(true);" 
                                          ontouchstart="tibibo.node.edit.refresh(true);event.preventDefault();">
                    <div class="icon"><img src="res/img/classification/root.svg"/></div>
                    <div class="star"><img src="res/img/default/icon/menu01st0.svg"/></div>
            </div>
            <textarea id="elabel" autocomplete="off" autocorrect="off" autocapitalize="off" spellcheck="false"
                    onfocusout="tibibo.node.edit.refresh(false);"></textarea>
            <textarea id="ecomment" autocomplete="off" autocorrect="off" autocapitalize="off" spellcheck="false"
                    onfocusout="tibibo.node.edit.refresh(false);"></textarea>
            <div id="tibibi">
                <select></select>
                <div class="icon" onclick="tibibo.node.edit.tibibi();" 
                                  ontouchstart="tibibo.node.edit.tibibi();event.preventDefault();">
                    <img src="res/img/default/white/import.svg"/></div>
                <textarea id="etibibi" autocomplete="off" autocorrect="off" autocapitalize="off" spellcheck="false"
                    onfocusout="tibibo.node.edit.refresh(false);"
                    onkeyup="tibibo.node.edit.refresh(false);"></textarea>
            </div>
        </div>
        <div>
            <div class="icon" id="ecancel" onclick="tibibo.node.edit.close();" 
                                          ontouchstart="tibibo.node.edit.close();event.preventDefault();">
                <img src="res/img/default/white/cancel02.svg"/>
            </div>
            <div class="icon" id="evalid" onclick="tibibo.node.edit.valid();" 
                                         ontouchstart="tibibo.node.edit.valid();event.preventDefault();">
                <img src="res/img/default/white/valid02.svg"/>
            </div>
        </div>
      </div>

      <div id="eimg"></div>
    </div>
    
    <div id="bosplash"><div><div id="bolabel"></div></div></div>

  </div>
{% include 'templates/global.js.html' %}
</body>
